# MyQuote by fragp <jb@fragp.com>
# - See README for further information.

####
# MySQL variables:

# hostname
set db(host)          "localhost"
# user
set db(id)            "user"
# password
set db(pass)          "password"
# database
set db(dbase)         "database"
# tables
set db(tbl_quote)     "quote"
set db(tbl_quotechan) "quotechan"
set db(tbl_quoterate) "quoterate"


####
# other variables:

# channel auto add
set mqcfg(chan_autoadd)   "1"
# show quoteinfo automagic on quoterequest
set mqcfg(quoteinfo)      "0"
# append hostmask on quoteinfo
set mqcfg(quoteinfo_host) "0"
# url of the php
set mqcfg(url)            ""

# the char that marks public commands
set mqcfg(char) "."
# flag(s) needed to read quotes
set mqcfg(readflag) "-"
# flag(s) needed to add quotes
set mqcfg(addflag) "-"
# flag(s) needed to delete quotes
set mqcfg(delflag) "m"
# flag(s) needed to make the bot set a random quote topic
set mqcfg(tpcflag) "o|o"



# --------------------------------------------------------------------
# MAGIC BORDER
# Don't cross this line unless you feel prepared to code
# --------------------------------------------------------------------

set mqcfg(version) "2.0"
setudef flag myquote

# load the mysqltcl interface
package req mysqltcl


# --------------------------------------------------------------------
# bindings
# --------------------------------------------------------------------

bind pub $mqcfg(readflag) ${mqcfg(char)}q           mq:quote
bind pub $mqcfg(readflag) ${mqcfg(char)}quote       mq:quote
bind pub $mqcfg(readflag) ${mqcfg(char)}ql          mq:lastquote
bind pub $mqcfg(readflag) ${mqcfg(char)}lastquote   mq:lastquote
bind pub $mqcfg(readflag) ${mqcfg(char)}qr          mq:quoterate
bind pub $mqcfg(readflag) ${mqcfg(char)}quoterate   mq:quoterate
bind pub $mqcfg(readflag) ${mqcfg(char)}qt          mq:quotetop
bind pub $mqcfg(readflag) ${mqcfg(char)}quotetop    mq:quotetop
bind pub $mqcfg(readflag) ${mqcfg(char)}qs          mq:quotesearch
bind pub $mqcfg(readflag) ${mqcfg(char)}quotesearch mq:quotesearch
bind pub $mqcfg(readflag) ${mqcfg(char)}qi          mq:quoteinfo
bind pub $mqcfg(readflag) ${mqcfg(char)}quoteinfo   mq:quoteinfo
bind pub $mqcfg(readflag) ${mqcfg(char)}qh          mq:quotehelp
bind pub $mqcfg(readflag) ${mqcfg(char)}quotehelp   mq:quotehelp
bind pub $mqcfg(readflag) ${mqcfg(char)}qs          mq:quotestats
bind pub $mqcfg(readflag) ${mqcfg(char)}quotestats  mq:quotestats
bind pub $mqcfg(addflag) ${mqcfg(char)}qa           mq:addquote
bind pub $mqcfg(addflag) ${mqcfg(char)}addquote     mq:addquote
bind pub $mqcfg(delflag) ${mqcfg(char)}qd           mq:delquote
bind pub $mqcfg(delflag) ${mqcfg(char)}delquote     mq:delquote
if {$mqcfg(url) != ""} {
  bind pub $mqcfg(readflag) ${mqcfg(char)}quotesite mq:quotesite
}

bind dcc - quote mq:dccquote

# --------------------------------------------------------------------
# procedures
# --------------------------------------------------------------------

proc mq:constructor {nick uhost handle chan} {
   global db mq
   
   # store meta-infos
   set mq(nick)   $nick
   set mq(uhost)  $uhost
   set mq(handle) $handle
   set mq(chan)   $chan
   
   # open database connection
   set db(sqlhand) [mysqlconnect -host $db(host) -user $db(id) -password $db(pass)]
   mysqluse $db(sqlhand) $db(dbase)
   
   # is chan enabled for quoting?
   set mq(chan_id) [mq:validchan]
   if {!$mq(chan_id)} {
      putnotc $nick "Quotes are disabled for this channel"
      return 0
   }

   return 1
}

proc mq:destructor {} {
    global db mq
    
    mysqlclose $db(sqlhand)
    return 1
}


proc mq:validchan {} {
    global db mq mqcfg
    
    if {[channel get $mq(chan) myquote]} {
        set qry "SELECT id FROM $db(tbl_quotechan) WHERE chan = '$mq(chan)'"
        set chanid [mysqlsel $db(sqlhand) $qry -list]
        if {$chanid > 0} {
            return $chanid
        } else {
            # auto-add
            if {$mqcfg(chan_autoadd)} {
                set qry "INSERT INTO $db(tbl_quotechan) SET chan = '$mq(chan)', added = NOW()"
                mysqlexec $db(sqlhand) $qry
                putlog "<<$mq(nick)>> !$mq(handle)! Created channel $chan"
                return [mysqlinsertid $db(sqlhand)]
            }
        }
    }
    return 0
}

proc mq:_checkquoteid {id} {
    global db mq mqcfg
    
    set qry "SELECT COUNT(id) FROM quote WHERE id = '[mysqlescape $id]'"
    set count [mysqlsel $db(sqlhand) $qry -list]
    
    if {$count > 0} {
        return 1
    }
    return 0
}

# debug
proc mq:dccquote {handle idx arg} {
    #mq:quote $idx "" $handle [lindex $arg 0] [lindex $arg 1]
    #mq:addquote $idx "" $handle $arg "" 
    mq:quotetop $idx "" $handle [lindex $arg 0] [lrange $arg 1 end]
    #mq:quotesearch $idx "" $handle [lindex $arg 0] [lindex $arg 1]
    #mq:quoterate $idx "" $handle [lindex $arg 0] [lrange $arg 1 end]
}


# quote
proc mq:quote {nick uhost handle chan arg} {
    global db mq
    if {![mq:constructor $nick $uhost $handle $chan]} { return 0 }
    
    set count 1
    if {$arg == ""} {
        set qry "SELECT id
                 FROM $db(tbl_quote)
                 WHERE chan_id = $mq(chan_id)
                 ORDER BY RAND() LIMIT 1"
        set id [mysqlsel $db(sqlhand) $qry -list]
        set count 0
        
    } elseif {[string is integer $arg]} {
        set qry "SELECT id
                 FROM $db(tbl_quote)
                 WHERE chan_id = $mq(chan_id) AND
                       quote_id = '$arg'"
        set id [mysqlsel $db(sqlhand) $qry -list]
    
    } elseif {$arg == "-g"} {
        set qry "SELECT id
                 FROM $db(tbl_quote)
                 ORDER BY RAND() LIMIT 1"
        set id [mysqlsel $db(sqlhand) $qry -list]
        set count 0
        
    } elseif {[lindex $arg 0] == "-gc" && [lindex $arg 1] != ""} {
        set qry "SELECT q.id
                 FROM $db(tbl_quote) AS q, $db(tbl_quotechan) AS qc
                 WHERE q.chan_id = qc.id
                       AND qc.chan = '[mysqlescape [lindex $arg 1]]'
                 ORDER BY RAND() LIMIT 1"
        set id [mysqlsel $db(sqlhand) $qry -list]
        set count 0

    } elseif {[lindex $arg 0] == "-gid" && [string is integer [lindex $arg 1]]} {
        set qry "SELECT id
                 FROM $db(tbl_quote)
                 WHERE id = '[lindex $arg 1]'"
        set id [mysqlsel $db(sqlhand) $qry -list]
        
    } else {
        # search
        mq:quotesearch $nick $uhost $handle $chan $arg
        return 1
    }

    if {$id > 0 && $count == 1} {
        # count
        set qry "UPDATE $db(tbl_quote)
                 SET views = views + 1
                 WHERE id = '$id'"
        mysqlexec $db(sqlhand) $qry
    }
    
    mq:quoteput $id $arg
}

# lastquote
proc mq:lastquote {nick uhost handle chan arg} {
    global db mq
    if {![mq:constructor $nick $uhost $handle $chan]} { return 0 }
    
    if {$arg == ""} {
        set qry "SELECT id
                 FROM $db(tbl_quote)
                 WHERE chan_id = $mq(chan_id)
                 ORDER BY `date` DESC
                 LIMIT 1"
        set id [mysqlsel $db(sqlhand) $qry -list]
        
    } elseif {$arg == "-g"} {
        set qry "SELECT id
                 FROM $db(tbl_quote)
                 ORDER BY `date` DESC
                 LIMIT 1"
        set id [mysqlsel $db(sqlhand) $qry -list]
    }
    
    mq:quoteput $id $arg
}

# quoteput
proc mq:quoteput {id arg} {
    global db mq mqcfg
    
    if {$id > 0} {        
        # select
        set qry "SELECT quote_id, chan_id, quote
                 FROM $db(tbl_quote)
                 WHERE id = '$id'"
        set row [lindex [mysqlsel $db(sqlhand) $qry -list] 0]
        
        # quote
        set quote_id [lindex $row 0]
        set chan_id  [lindex $row 1]
        set quote    [lindex $row 2]
        
        if {$chan_id == $mq(chan_id)} {
            set quote "Quote #$quote_id: $quote"
        } else {
            # -g
            set qry "SELECT chan
                     FROM $db(tbl_quotechan)
                     WHERE id = '$chan_id'"
            set chan [mysqlsel $db(sqlhand) $qry -list]
            set quote "[string range $chan 1 [string length $chan]]-Quote #$quote_id \[-gid $id\]: $quote"
        }
        
        putchan $mq(chan) $quote
        if {$mqcfg(quoteinfo) == 1} {
            mq:_quoteinfo $mq(nick) $mq(uhost) $mq(handle) $mq(chan) $id 1
        }
        putlog "<<$mq(nick)>> !$mq(handle)! Requested a quote in $mq(chan)"

    } else {
        putnotc $mq(nick) "No Quote(s) found"
    }
}


# addquote
proc mq:addquote {nick uhost handle chan arg} {
    global db mq
    if {![mq:constructor $nick $uhost $handle $chan]} { return 0 }

    # quote_id for channel
    set qry "SELECT IF(ISNULL(MAX(quote_id)), 0, MAX(quote_id))
             FROM $db(tbl_quote)
             WHERE chan_id = $mq(chan_id)"
    set quote_id [expr [mysqlsel $db(sqlhand) $qry -list] + 1]
    
    # insert quote
    set qry "INSERT INTO $db(tbl_quote)
             SET quote_id   = $quote_id,
                 chan_id    = $mq(chan_id),
                 quote      = '[mysqlescape [mirc_strip $arg]]',
                 author     = '[mysqlescape $nick]',
                 handle     = '[mysqlescape $handle]',
                 host       = '[mysqlescape $uhost]',
                 date       = NOW()"
    mysqlexec $db(sqlhand) $qry
    
    putlog "<<$nick>> !$handle! Added a quote in $chan"
    mq:_quoteinfo $mq(nick) $mq(uhost) $mq(handle) $mq(chan) [mysqlinsertid $db(sqlhand)] 1
    putnotc $nick "Quote #$quote_id added"
    
    mq:destructor
}


# delquote
proc mq:delquote {nick uhost handle chan arg} {
    global db mq
    if {![mq:constructor $nick $uhost $handle $chan]} { return 0 }

    if {[string is integer $arg]} {
        set qry "DELETE FROM $db(tbl_quote)
                 WHERE chan_id = '$mq(chan_id)' AND
                       quote_id = '$arg'"

    } elseif {[lindex $arg 0] == "-gid" && [string is integer [lindex $arg 1]]} {
        set qry "DELETE FROM $db(tbl_quote)
                 WHERE id = '$arg'"

    } else {
        putnotc $nick "No such quote"
    }

    mysqlexec $db(sqlhand) $qry
    putlog "<<$nick>> !$handle! Deleted a quote in $chan"
    putnotc $nick "Quote deleted"
}


# quotesearch
proc mq:quotesearch {nick uhost handle chan arg} {
    global db mq
    if {![mq:constructor $nick $uhost $handle $chan]} { return 0 }

    if {$arg == ""} {
        return 0
    }   
     
    set qry "SELECT id, quote_id
             FROM $db(tbl_quote)
             WHERE chan_id = $mq(chan_id) AND
                   quote LIKE '%$arg%'
             ORDER BY quote_id
             LIMIT 50"
                   
    set rows [mysqlsel $db(sqlhand) $qry -list]
    
    set searchcount 0
    for {set i 0} {$i < [llength $rows]} {incr i} {
        set row [lindex $rows $i]
        lappend search "#[lindex $row 1]"
        incr searchcount
    }

    if {$searchcount == 0} {
        putnotc $nick "No matching Quotes found."
        return 0
    }

    if {$searchcount > 1} {
        set search [join $search " "]
        putchan $chan "Quotes matching criteria: $search"

    } elseif {$searchcount == 1} {
        mq:quoteput [lindex $row 0] $arg

    }

    return 1
}


# public-quoteinfo
proc mq:quoteinfo {nick uhost handle chan arg} {
    global db mq
    if {![mq:constructor $nick $uhost $handle $chan]} { return 0 }

    if {$arg == ""} {
        return 0

    } elseif {[lindex $arg 0] == "-gid" && [string is integer [lindex $arg 1]]} {
        set id [lindex $arg 1]

    } elseif {[string is integer $arg]} {
        set qry "SELECT id
                 FROM $db(tbl_quote)
                 WHERE chan_id = $mq(chan_id) AND
                       quote_id = '$arg'"
        set id [mysqlsel $db(sqlhand) $qry -list]
    }

    mq:_quoteinfo $nick $uhost $handle $chan $id 0
    mq:destructor
}

# internal-quoteinfo
proc mq:_quoteinfo {nick uhost handle chan arg notc} {
    global db mq mqcfg
    if {![mq:constructor $nick $uhost $handle $chan]} { return 0 }

    # select
    set qry "SELECT q.id, q.chan_id, q.quote_id, q.author, q.host, q.handle, q.views, q.date,
                    IFNULL(SUM(qr.rating), 0)
             FROM $db(tbl_quote) AS q
                LEFT JOIN $db(tbl_quoterate) AS qr
                ON q.id = qr.id
             WHERE q.id = '$arg'
             GROUP BY q.id"
    set row [lindex [mysqlsel $db(sqlhand) $qry -list] 0]
    
    # author
    if {[lindex $row 5] == "*" || [lindex $row 5] == ""} {
        set author "[lindex $row 3]"
        if {[lindex $row 4] != "" && $mqcfg(quoteinfo_host)} {
            append author "![lindex $row 4]"
        }
    } else {
        set author [lindex $row 5]
    }
    
    set prefix ""
    if {[lindex $row 1] != $mq(chan_id)} {
        set qry "SELECT chan
                 FROM $db(tbl_quotechan)
                 WHERE id = '[lindex $row 1]'"
        set info_chan [mysqlsel $db(sqlhand) $qry -list]
        set prefix "[string range $info_chan 1 [string length $info_chan]]-"
    }

    # quoteinfo
    set    quoteinfo $prefix
    append quoteinfo "Quoteinfo #[lindex $row 2] \[-gid [lindex $row 0]\]: rating [lindex $row 8]; views [lindex $row 6]; added on [lindex $row 7] from <$author>"
    #append quoteinfo " - more? .quotehelp helps!"
    
    if {$notc != 1} {
        putchan $chan $quoteinfo
    } else {
        putnotc $nick $quoteinfo
    }
}


# quoterate
proc mq:quoterate {nick uhost handle chan arg} {
    global db mq
    if {![mq:constructor $nick $uhost $handle $chan]} { return 0 }   
    
    set error_syntax   "syntax error, try: quoterate \[-gid\] <id> <+|-|++|-->"
    set error_noquote  "There is no quote with that id."
    
    if {[lindex $arg 0] == "-gid" && [string is integer [lindex $arg 1]] && [mq:_checkquoteid [lindex $arg 1]]} {
        set qry "SELECT quote_id
                 FROM $db(tbl_quote)
                 WHERE id = '[lindex $arg 1]'"
        set quote_id [mysqlsel $db(sqlhand) $qry -list]
        set id [lindex $arg 1]
        set arg [lrange $arg 1 end]
        
    } elseif {[lindex $arg 0] != "-gid" && [string is integer [lindex $arg 0]]} {
        set qry "SELECT id
                 FROM $db(tbl_quote)
                 WHERE chan_id = $mq(chan_id) AND
                       quote_id = '[lindex $arg 0]'"
        set quote_id [lindex $arg 0]
        set id [mysqlsel $db(sqlhand) $qry -list]
                       
        if {$id <= 0} {
            putnotc $nick $error_noquote
            return 0
        }
        
    } else {
        putnotc $nick $error_syntax
        return 0
    }
    
    # spam-protection
    set qry "SELECT COUNT(*)
             FROM quoterate
             WHERE id     = '$id' AND
                   uhost  = '[mysqlescape $uhost]' AND
                   NOW() <= DATE_ADD(timestamp, INTERVAL 1 DAY)
             ORDER BY timestamp DESC"
    set spamc [mysqlsel $db(sqlhand) $qry -list]
    if {$spamc > 0} {
        #putnotc $nick "You can rate the same quote only every 24 hours"
        return 0
    }
    
    
    set rating 0
    if {[lindex $arg 1] == "++"} {
        set rating 2
    }
    if {[lindex $arg 1] == "+"} {
        set rating 1
    }
    if {[lindex $arg 1] == "-"} {
        set rating -1
    }
    if {[lindex $arg 1] == "--"} {
        set rating -2
    }
    
    if {$rating == 0} {
        putnotc $nick $error_syntax
        return 0
    }
    
    set qry "INSERT INTO quoterate
             SET id        = '$id',
                 rating    = '$rating',
                 uhost     = '[mysqlescape $uhost]',
                 timestamp = NOW()"
    mysqlexec $db(sqlhand) $qry
    
    putnotc $nick "Quote #$quote_id \[-gid $id\] rated: [lindex $arg 1]"
    mq:destructor
}


# quotetop
proc mq:quotetop {nick uhost handle chan arg} {
    global db mq
    if {![mq:constructor $nick $uhost $handle $chan]} { return 0 }

    if {$arg == "views"} {
        set limit 5
        set qry "SELECT quote_id, views
                 FROM $db(tbl_quote)
                 WHERE chan_id = '$mq(chan_id)' AND
                       views > 0
                 ORDER BY views DESC
                 LIMIT $limit"
        set rows [mysqlsel $db(sqlhand) $qry -list]
        
        if {$rows != ""} {
            list top ""
            for {set i 0} {$i < [llength $rows]} {incr i} {
                set row [lindex $rows $i]
                lappend top "[lindex $row 1]x #[lindex $row 0]"
            }
            set top [join $top " / "]
            putchan $chan "TopViewed Quotes: $top"

        } else {
            putchan $chan "No Quotes viewed yet"
        }
    }
    
    
    if {$arg == "rating"} {
        set limit 5
        set qry "SELECT q.quote_id, IFNULL(SUM(qr.rating), 0) AS rating
                 FROM $db(tbl_quote) AS q
                    LEFT JOIN $db(tbl_quoterate) AS qr
                    ON q.id = qr.id
                 WHERE q.chan_id = '$mq(chan_id)'
                 GROUP BY q.id
                    HAVING rating > 0
                 ORDER BY rating DESC, q.quote_id
                 LIMIT $limit"
        set rows [mysqlsel $db(sqlhand) $qry -list]
        
        if {$rows != ""} {
            list top ""
            for {set i 0} {$i < [llength $rows]} {incr i} {
                set row [lindex $rows $i]
                lappend top "[expr $i+1]. #[lindex $row 0]"
            }
            set top [join $top " / "]
            putchan $chan "TopRated Quotes: $top"

        } else {
            putnotc $nick "No Quotes rated yet"
        }
    }
    
    mq:destructor
}


# quotestats
proc mq:quotestats {nick uhost handle chan arg} {
    global db mq
    if {![mq:constructor $nick $uhost $handle $chan]} { return 0 }

    if {[lindex $arg 0] == "-t"} {
        set qry   "SHOW TABLE STATUS LIKE '$db(tbl_quote)'"
        set row   [lindex [mysqlsel $db(sqlhand) $qry -list] 0]
        putchan $chan "totals: [lindex $row 4] Quotes in database, using [format %.2f [expr [lindex $row 6] / 1024.0]] KB"
    } else {
        set qry "SELECT COUNT(*), IF(ISNULL(SUM(views)), 0, SUM(views)), MAX(quote_id)
                 FROM $db(tbl_quote)
                 WHERE chan_id = '$mq(chan_id)'"
        set row [lindex [mysqlsel $db(sqlhand) $qry -list] 0]
        putchan $chan "stats: latest Quote-#[lindex $row 2]; total [lindex $row 0] Quotes; [lindex $row 1] total views"
    }

    mq:destructor
}


# quotehelp
proc mq:quotehelp {nick uhost handle chan arg} {
    global db mq mqcfg
    if {![mq:constructor $nick $uhost $handle $chan]} { return 0 }

    putchan $chan "try: $mqcfg(char)quoteinfo \[-gid\] <id> | $mqcfg(char)quoterate \[-gid\] <id> <++|+|-|--> | $mqcfg(char)quotetop <views|rating> | $mqcfg(char)quotestats \[-t\]"
    mq:destructor
}


# quotesite
proc mq:quotesite {nick uhost handle chan arg} {
    global mqcfg
    putmsg $chan "chan quotes @ $mqcfg(url)?chan=[string range $chan 1 end]"
}


# --------------------------------------------------------------------
# moretools stuff by MC_8 - Carl M. Gregory <mc8@purehype.net>
# --------------------------------------------------------------------

proc mirc_strip {{args ""}} {
	set switches ""
	if {$switches == ""} {set switches all}
	set arg [lindex $args 0]
	set all [expr {([lsearch -exact $switches all] >= 0) ? 1 : 0}]
	set list [list \002 "" \017 "" \026 "" \037 ""]
	regsub -all -- "\003(\[0-9\]\[0-9\]?(,\[0-9\]\[0-9\]?)?)?" $arg "" arg
	set arg [replace -- $arg [join $list]]
	return $arg
}

# EOF
putlog "MyQuote v$mqcfg(version) loaded"
